#include <stdio.h>


void GraphStats(int matrix[][6], int n, char ori) {
    int edges = 0;
    int rebra = 0;
    
    for (int i = 0; i < n; i++){
        for (int k = 0; k < n; k++)
            if(matrix[i][k]) {
                edges += 1;break;
            }
        for (int k = 0; k < n; k++)if(matrix[i][k])rebra++;}
    
    if (ori)printf("Ori"); else printf("Unori");
    printf("riented Graph Stats:\n");
    if (!ori)rebra/=2;
    printf("Edges: %d\n", edges);
    printf("rebra: %d\n", rebra);
}

int main() {
    int cumNodes = 6;
    int G[6][6] = {
        {0, 1, 0, 1, 0, 0},
        {1, 0, 1, 0, 1, 1},
        {0, 1, 0, 1, 0, 0},
        {1, 0, 1, 0, 1, 1},
        {0, 1, 0, 1, 0, 0},
        {0, 1, 0, 1, 0, 0}
    };
    int G1[6][6] = {
        {0, 1, 0, 1, 0, 0},
        {0, 0, 1, 0, 1, 0},
        {0, 0, 0, 0, 0, 1},
        {0, 0, 1, 0, 1, 0},
        {0, 0, 0, 0, 0, 1},
        {0, 0, 0, 0, 0, 0}
    };
    int H[6][6] = {
        {0, 1, 1, 0, 0, 0},
        {1, 0, 1, 1, 1, 0},
        {1, 1, 0, 1, 1, 0},
        {0, 1, 1, 0, 1, 1},
        {0, 1, 1, 1, 0, 1},
        {0, 0, 0, 1, 1, 0}
    };
    int H1[6][6] = {
        {0, 1, 0, 1, 0, 0},
        {0, 0, 1, 1, 0, 0},
        {0, 0, 0, 0, 0, 1},
        {0, 0, 1, 0, 1, 0},
        {0, 0, 0, 0, 0, 1},
        {0, 0, 0, 0, 0, 0}
    };
    
    
    int result[6][6];
    printf("Supplement to the graph G:\n");
    for (int i = 0; i < cumNodes; i++) {
        for (int j = 0; j < cumNodes; j++) {
            if (i == j) {
                result [i][j] = 0;
                printf("0 ");
            } else {
                printf("%d ", !G[i][j]);
                result [i][j] = !G[i][j];
            }
        }
        printf("\n");
    }
    printf("\n");
    GraphStats(result, cumNodes,0);
    
    
    
    printf("Supplement to the graph G1:\n");
    for (int i = 0; i < cumNodes; i++) {
        for (int j = 0; j < cumNodes; j++) {
            if (i == j) {
                result [i][j] = 0;
                printf("0 ");
            } else {
                printf("%d ", !G1[i][j]);
                result [i][j] = !G[i][j];
            }
        }
        printf("\n");
    }
    printf("\n");
    GraphStats(result, cumNodes,1);
    
    
    
    printf("Intersection of graphs G and H:\n");
    for (int i = 0; i < cumNodes; i++) {
        for (int j = 0; j < cumNodes; j++) {
            result[i][j] = G[i][j] & H[i][j];
            printf("%d ", result[i][j]);
        }
        printf("\n");
    }
    printf("\n");
    GraphStats(result, cumNodes,0);
    
    
    
    printf("Intersection of graphs G1 and H1:\n");
    for (int i = 0; i < cumNodes; i++) {
        for (int j = 0; j < cumNodes; j++) {
            result[i][j] = G1[i][j] & H1[i][j];
            printf("%d ", result[i][j]);
        }
        printf("\n");
    }
    printf("\n");
    GraphStats(result, cumNodes,1);
    
    
    
    printf("Union of graphs G and H:\n");
    for (int i = 0; i < cumNodes; i++) {
        for (int j = 0; j < cumNodes; j++) {
            result[i][j] = G[i][j] | H[i][j];
            printf("%d ", result[i][j]);
        }
        printf("\n");
    }
    printf("\n");
    GraphStats(result, cumNodes,0);
    
    
    printf("Union of graphs G1 and H1:\n");
    for (int i = 0; i < cumNodes; i++) {
        for (int j = 0; j < cumNodes; j++) {
            result[i][j] = G1[i][j] | H1[i][j];
            printf("%d ", result[i][j]);
        }
        printf("\n");
    }
    printf("\n");
    GraphStats(result, cumNodes,1);
    
    
    
    printf("Difference of graphs G \\ H:\n");
    for (int i = 0; i < cumNodes; i++) {
        for (int j = 0; j < cumNodes; j++) {
            int difference = G[i][j] - H[i][j];
            if (difference < 0) {
                result[i][j] = 0;
            } else {
                result[i][j] = difference;
            }
            printf("%d ", result[i][j]);
        }
        printf("\n");
    }
    printf("\n");
    GraphStats(result, cumNodes,0);
    
    
    
    printf("Difference of graphs G1 \\ H1:\n");
    for (int i = 0; i < cumNodes; i++) {
        for (int j = 0; j < cumNodes; j++) {
            int difference = G1[i][j] - H1[i][j];
            if (difference < 0) {
                result[i][j] = 0;
            } else {
                result[i][j] = difference;
            }
            printf("%d ", result[i][j]);
        }
        printf("\n");
    }
    printf("\n");
    GraphStats(result, cumNodes,1);
    
    
    
    printf("Symmetric difference of graphs G and H:\n");
    for (int i = 0; i < cumNodes; i++) {
        for (int j = 0; j < cumNodes; j++) {
            result[i][j] = G[i][j] ^ H[i][j];
            printf("%d ", result[i][j]);
        }
        printf("\n");
    }
    printf("\n");
    GraphStats(result, cumNodes,0);
    
    
    printf("Symmetric difference of graphs G1 and H1:\n");
    for (int i = 0; i < cumNodes; i++) {
        for (int j = 0; j < cumNodes; j++) {
            result[i][j] = G1[i][j] ^ H1[i][j];
            printf("%d ", result[i][j]);
        }
        printf("\n");
    }
    printf("\n");
    GraphStats(result, cumNodes,1);
    
    
    return 0;
}
